package com.gree.mall.manager.commonmapper;

import com.baomidou.mybatisplus.annotation.SqlParser;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gree.mall.manager.bean.settle.repair.*;
import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

@Mapper
public interface DailyMapper {
    /**
     * 扣回的
     * @param importBatchNo
     */
    @SqlParser(filter = true)
    void bindWorkerNumber2(@Param("companyWechatId") String companyWechatId, @Param("importBatchNo") String importBatchNo);

    /**
     * 汇总结算-绑定师傅编号
     * @param importBatchNo
     */
    @SqlParser(filter = true)
    void bindWorkerNumber(@Param("companyWechatId") String companyWechatId, @Param("importBatchNo") String importBatchNo);
    /**
     * 汇总结算-查询重复的
     */
    @SqlParser(filter = true)
    List<String> queryDistinctOrderNo(@Param("companyWechatId") String companyWechatId);

    @SqlParser(filter = true)
    List<DailyTotalCostBean> queryDailyTotalCost(
            @Param("companyWechatId") String companyWechatId,
            @Param("importBatchNo") String importBatchNo,
            @Param("status") List<Integer> status,
            @Param("needSummaryStatus") List<String> needSummaryStatus
    );

    @SqlParser(filter = true)
    List<DailyIncrDecrCostCountBean> queryIncrDecrByBatch(
            @Param("companyWechatId") String companyWechatId,
            @Param("importBatchNo") String importBatchNo,
            @Param("status") Integer status
    );

    @MapKey(value = "summaryNumber")
    List<Map<String,Object>>  querySummaryNumber(
            @Param("companyWechatId") String companyWechatId,
            @Param("summaryBatchNo") String summaryBatchNo
    );

    @MapKey(value = "summaryNumber")
    List<Map<String,Object>>  querySummaryMonthNumber(
            @Param("companyWechatId") String companyWechatId,
            @Param("summaryBatchNo") String summaryBatchNo
    );

    List<DailyWokerBankCardMonthBean> queryIssueSalaryMonthBankCardInfo(
            @Param("summaryBatchNo") String summaryBatchNo,
            @Param("summaryNumber") String summaryNumber,
            @Param("status") Integer status,
            @Param("companyWechatId") String companyWechatId);

    List<DailyWorkerBankCardBean> queryIssueSalaryAndBankCardInfo(
            @Param("summaryBatchNo") String summaryBatchNo,
            @Param("summaryNumber") String summaryNumber,
            @Param("status") Integer status,
            @Param("companyWechatId") String companyWechatId
    );

    List<DailySummaryDataBean> summaryDayList(@Param("summaryBatchNo") String summaryBatchNo,
                                              @Param("companyWechatIds") List<String> companyWechatIds,
                                              @Param("adminWebsitIds") List<String> adminWebsitIds);

    IPage<DailySummaryDataBean> cwSummaryList(Page page,
                                              @Param("summaryBatchNo") String summaryBatchNo,
                                              @Param("summaryStartTime") String summaryStartTime,
                                              @Param("summaryEndTime") String summaryEndTime,
                                              @Param("issueStartTime") String issueStartTime,
                                              @Param("issueEndTime") String issueEndTime,
                                              @Param("status") Integer status,
                                              @Param("companyWechatIds") List<String> companyWechatIds,
                                              @Param("adminWebsitIds") List<String> adminWebsitIds);

    IPage<DailyWorkerIssueSalaryBean> workerDetailList(Page page,
                                                       @Param("issueSalaryId") Integer issueSalaryId,
                                                       @Param("companyWechatIds") List<String> companyWechatIds,
                                                       @Param("adminWebsitIds") List<String> adminWebsitIds);
}
